/*************************************************** */
/* Rule Set Based Access Control                     */
/*                                                   */
/* Author and (c) 1999-2006: Amon Ott <ao@rsbac.org> */
/*                                                   */
/* Last modified: 13/Jan/2006                        */
/*************************************************** */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <linux/kdev_t.h>
#include <rsbac/types.h>
#include <rsbac/syscalls.h>
#include <rsbac/getname.h>
#include <rsbac/error.h>
#include "nls.h"
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

char * progname;

void use(void)
{
      printf(gettext("%s (RSBAC %s)\n***\n"), progname, VERSION);
      printf(gettext("Use: %s correct\n"), progname);
      printf(gettext("     correct = 0: do not correct errors\n"));
      printf(gettext("     correct = 1: correct errors\n"));
      printf(gettext("     correct = 2: correct more\n"));
}

int main(int argc, char ** argv)
{
  int res = 0;
  int correct;
  int check_inode;

  locale_init();

  progname = argv[0];

  while((argc > 1) && (argv[1][0] == '-'))
    {
      char * pos = argv[1];
      pos++;
      while(*pos)
        {
          switch(*pos)
            {
              case 'h':
                use();
                return 0;
              case 'v':
                res = rsbac_version();
                error_exit(res);
                printf("%u.%u.%u\n", res >> 16, (res >> 8) & 255, res & 255);
                return 0;
              case 'V':
                res = rsbac_version();
                error_exit(res);
                printf("%u\n", res);
                return 0;
              default:
                fprintf(stderr, gettext("%s: unknown parameter %c\n"), progname, *pos);
                exit(1);
            }
          pos++;
        }
      argv++;
      argc--;
    }

  if (argc >= 2)
    {
      correct=strtol(argv[1],0,10);
      res = rsbac_check(correct);
      error_exit(res);
    }
  else
    {
      use();
    }
  return (res);
}
